#ifndef _MAPFILE_H
#define _MAPFILE_H

#include "defs.h"
#include "zzlib.h"
#include "mapas.h"

#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>

#include "allegro.h"

#define COMPRIMIDO 1
#define EFECTO 2
#define MAPA_EDITABLE 4
#define JUGABLE 8

LOGICO cargarMapa(char *nombre, unsigned char *flags, CADENA *nombre_pcxs,\
	CABECERA *cabecera, MAPA mapa, PALANCAS palancas, ENERGIAS energias,\
	BITMAP **fondos, BITMAP **tiles, BITMAP **sprites, int *n_efec);

LOGICO cargarMapaFormatoAntiguo(char *nombre, CADENA *nombre_pcxs,\
	CABECERA *cabecera, MAPA mapa, PALANCAS palancas, ENERGIAS energias,\
	BITMAP **fondos, BITMAP **tiles, BITMAP **sprites, int *n_efec);

LOGICO grabarMapa(char *nombre, unsigned char flags, CADENA *nombre_pcxs, \
	CABECERA cabecera, MAPA mapa, PALANCAS palancas, ENERGIAS energias,\
	BITMAP **fondos, BITMAP **tiles, BITMAP **sprites, int n_efec);

LOGICO esEditable(unsigned char);
LOGICO esJugable(unsigned char);
LOGICO estaComprimido(unsigned char);
LOGICO tieneEfecto(unsigned char);
#endif
