#include <allegro.h>
#include <fmod.h>
#include "defs.h"
#include "gfx.h"
#include "key.h"
#include "menu_intro.h"
#include "temporizadores.h"
#include "clave.h"
#include "closebuttonhandler.h"

void intro(BITMAP *buffer, BITMAP *loader, PALETTE dummy)
{
	BITMAP *cezgs;
	
	cezgs = load_pcx ("resources/splashretrocompo.pcx", dummy);
	blit (cezgs, screen, 0, 0, 0, 0, 512, 384);
	KEY_wait_action_key();
	
	cezgs = load_pcx ("resources/horrorosoft-logo.pcx", dummy);
	blit (cezgs, buffer, 0, 0, 28, 70, 200, 53);	
	destroy_bitmap (cezgs);
	
	GFX_blitall(buffer);
	
	KEY_wait_action_key();
}

int menu(LOGICO animation, BITMAP *buffer, BITMAP *loader, PALETTE dummy)
{
	int pos,ct = 0;
	int mpos = -1;
	int blink_ct = 0;
	short val1 = 0, val2 = 0;
	int chnl, i;
	int vpos = 0;
	BITMAP *she;
	BITMAP *buffer2;
	LOGICO terminado=FALSO,chg=CIERTO;
	int last_key_pressed = 0;
	
	loader=load_pcx("resources/title.pcx",dummy);
	
	buffer2 = create_bitmap (256, 192);
	
	while(key[KEY_ENTER]);
	
	for (i = 0; i < 64; i ++)
	{
		clear (buffer);
		fblend_add (loader, buffer, 0, 0, i << 2);
		
		vsync ();
		GFX_blitall (buffer);
	}
	
	i = 64;
	she=load_pcx("resources/MENU_She.pcx",dummy);
	pos=465;
	
	if (animation)
	{		
		ct = 0;
		
		while(ct < 4)
		{
			if (i > 0)
				i--;			
			
			//blit(loader,buffer,0,0,0,0,256,192);
			// masked_blit(she,buffer,0,pos,0,0,256,192);

			clear (buffer);
			fblend_add (loader, buffer, 0, 0, 192 + (rand () & 63));
			
			if (blink_ct > 0) {
				
				if ((rand () & 7) == 0) {
					val1 = (rand () & 7) - 4;
					val2 = (rand () & 7) - 4;
					vpos = rand () % 192;
				}
				
				blit (she, buffer2, 0, pos, 0, 0, 256, 192);
				fblend_add (buffer2, buffer, 0, 0, 32 - (i>>1) - (ct<<1));
				
				blit (she, buffer2, val1, pos, 0, 0, 256, vpos);
				blit (she, buffer2, val2, pos+vpos, 0, vpos, 256, 192-vpos);
				
				fblend_add (buffer2, buffer, 0, 0, 32 + (rand () & 64) - i - (ct<<2));
				blink_ct --;
			} else {
				blit (she, buffer2, 0, pos, 0, 0, 256, 192);
				fblend_add (buffer2, buffer, 0, 0, 64 - i - (ct<<2));
			}
			
			if ((rand () & 31) == 0)
				blink_ct = 15 + (rand () & 15);
			//blit (buffer2, buffer, 0,0,0,0, 256, 192);
			
			GFX_centra(buffer,184,-1,"PRESS ENTER");
			vsync (); vsync ();
			GFX_blitall(buffer);
						
			pos += mpos;
			
			if (pos == 0 || pos == 465)
				mpos = -mpos;
					
			if (key[KEY_ENTER] && !key[KEY_ESC] && !close_button_pressed)
				ct = 1;
				
			if (ct > 0)
				ct ++;
		}
		
		// Flash: (he'll save everyone of us! - Just a man with a man's courage, etc...)
		/*
		rectfill(buffer,0,0,255,191,-1);
		GFX_blitall(buffer);
		while(contador_60Hz<2);
		contador_60Hz=0;
		// KING OF THE IMPOSSIBLE!!!!!
		*/
		
		
	}
	
	if (key [KEY_ESC])	
		close_button_pressed = 1;
	
	while(key[KEY_ENTER]);
	
	// Test 1:
	
	while(!terminado)
	{
		if (close_button_pressed)
		{
			terminado=CIERTO;
			MENU_opt=4;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_back);
				FSOUND_SetPan(chnl,128);
			}
		}
		
		if(key[KEY_ENTER])
		{
			terminado=CIERTO;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_go);
				FSOUND_SetPan(chnl,128);
			}
		}
		
		if(key[KEY_ESC])
		{
			terminado=CIERTO;
			MENU_opt=4;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_back);
				FSOUND_SetPan(chnl,128);
			}
		}
		
		//if(chg)
		{
			/*while(contador_60Hz<1);
			contador_60Hz=0;*/
						
			clear (buffer);
			fblend_add (loader, buffer, 0, 0, 192 + (rand () & 63));
			
			drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
			rectfill(buffer,72,80,184,152,0);
			GFX_centra(buffer,176,-1,"CODE & SFX: PHANTUMAKA");
			GFX_centra(buffer,184,-1,"GFX: PHANTUMAKA & CACIQUIN");
			GFX_centra(buffer,88,-1,"PLAY");
			GFX_centra(buffer,104,-1,"PASSWORD");
			GFX_centra(buffer,120,-1,"USER LEVEL");
			GFX_centra(buffer,136,-1,"EXIT");
			chg=FALSO;
			drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
			
			if (blink_ct > 0) {
				
				if ((rand () & 7) == 0) {
					val1 = (rand () & 7) - 4;
					val2 = (rand () & 7) - 4;
					vpos = rand () % 192;
				}
				
				blit (she, buffer2, 0, pos, 0, 0, 256, 192);
				fblend_add (buffer2, buffer, 0, 0, 32 - (i>>1) - (ct<<1));
				
				blit (she, buffer2, val1, pos, 0, 0, 256, vpos);
				blit (she, buffer2, val2, pos+vpos, 0, vpos, 256, 192-vpos);
				
				fblend_add (buffer2, buffer, 0, 0, 32 + (rand () & 64) - i - (ct<<2));
				blink_ct --;
			} else {
				blit (she, buffer2, 0, pos, 0, 0, 256, 192);
				fblend_add (buffer2, buffer, 0, 0, 64 - i - (ct<<2));
			}
			
			if ((rand () & 31) == 0)
				blink_ct = 15 + (rand () & 15);
			//blit (buffer2, buffer, 0,0,0,0, 256, 192);
			
			vsync (); vsync ();
			//GFX_blitall(buffer);
						
			pos += mpos;
			
			if (pos == 0 || pos == 465)
				mpos = -mpos;			
		}
		
		
		switch(MENU_opt)
		{
			case 1:
				GFX_centra(buffer,88,-1,"PLAY");
			break;
			case 2:
				GFX_centra(buffer,104,-1,"PASSWORD");
			break;
			case 3:
				GFX_centra(buffer,120,-1,"USER LEVEL");
			break;
			case 4:
				GFX_centra(buffer,136,-1,"EXIT");
			break;
		}
		
		if (key[KEY_UP] && last_key_pressed != key [KEY_UP]) {
			last_key_pressed = key[KEY_UP];
			MENU_opt--;
			if(MENU_opt<1)
				MENU_opt=4;
			chg=CIERTO;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_ting);
				FSOUND_SetPan(chnl,128);
			}
		} else if (key[KEY_DOWN] && last_key_pressed != key [KEY_DOWN]) {
			last_key_pressed = key[KEY_DOWN];
			MENU_opt++;
			if(MENU_opt>4)
				MENU_opt=1;
			chg=CIERTO;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_ting);
				FSOUND_SetPan(chnl,128);
			}
		} 
		
		if (!key [KEY_DOWN] && !key [KEY_UP])
			last_key_pressed = 0;
		
		if (!close_button_pressed)
			GFX_blitall(buffer);
	}
	
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

	destroy_bitmap(she);
	return(MENU_opt);
}
